Index: XIOS3/trunk/src/interface/fortran_attr/ifilegroup_attr.F90
===================================================================
--- XIOS3/trunk/src/interface/fortran_attr/ifilegroup_attr.F90	(revision 2614)
+++ XIOS3/trunk/src/interface/fortran_attr/ifilegroup_attr.F90	(revision 2616)
@@ -894,9 +1056,10 @@
   SUBROUTINE xios(is_defined_filegroup_attr_hdl_)   &
     ( filegroup_hdl, append_, comment_, compression_level_, convention_, convention_str_, cyclic_  &
-    , description_, enabled_, format_, group_ref_, min_digits_, mode_, name_, name_suffix_, output_freq_  &
-    , output_level_, par_access_, read_metadata_par_, record_offset_, split_end_offset_, split_freq_  &
-    , split_freq_format_, split_last_date_, split_start_offset_, sync_freq_, time_counter_, time_counter_name_  &
-    , time_stamp_format_, time_stamp_name_, time_units_, timeseries_, ts_prefix_, type_, uuid_format_  &
-    , uuid_name_ )
+    , description_, enabled_, format_, gatherer_, group_ref_, min_digits_, mode_, name_, name_suffix_  &
+    , output_freq_, output_level_, par_access_, pool_gatherer_, pool_reader_, pool_writer_, read_metadata_par_  &
+    , reader_, record_offset_, split_end_offset_, split_freq_, split_freq_format_, split_last_date_  &
+    , split_start_offset_, sync_freq_, time_counter_, time_counter_name_, time_stamp_format_, time_stamp_name_  &
+    , time_units_, timeseries_, ts_prefix_, type_, using_server2_, uuid_format_, uuid_name_, writer_  &
+     )
 
     IMPLICIT NONE
@@ -920,4 +1083,6 @@
       LOGICAL, OPTIONAL, INTENT(OUT) :: format_
       LOGICAL(KIND=C_BOOL) :: format__tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: gatherer_
+      LOGICAL(KIND=C_BOOL) :: gatherer__tmp
       LOGICAL, OPTIONAL, INTENT(OUT) :: group_ref_
       LOGICAL(KIND=C_BOOL) :: group_ref__tmp
@@ -936,6 +1101,14 @@
       LOGICAL, OPTIONAL, INTENT(OUT) :: par_access_
       LOGICAL(KIND=C_BOOL) :: par_access__tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: pool_gatherer_
+      LOGICAL(KIND=C_BOOL) :: pool_gatherer__tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: pool_reader_
+      LOGICAL(KIND=C_BOOL) :: pool_reader__tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: pool_writer_
+      LOGICAL(KIND=C_BOOL) :: pool_writer__tmp
       LOGICAL, OPTIONAL, INTENT(OUT) :: read_metadata_par_
       LOGICAL(KIND=C_BOOL) :: read_metadata_par__tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: reader_
+      LOGICAL(KIND=C_BOOL) :: reader__tmp
       LOGICAL, OPTIONAL, INTENT(OUT) :: record_offset_
       LOGICAL(KIND=C_BOOL) :: record_offset__tmp
@@ -968,8 +1141,12 @@
       LOGICAL, OPTIONAL, INTENT(OUT) :: type_
       LOGICAL(KIND=C_BOOL) :: type__tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: using_server2_
+      LOGICAL(KIND=C_BOOL) :: using_server2__tmp
       LOGICAL, OPTIONAL, INTENT(OUT) :: uuid_format_
       LOGICAL(KIND=C_BOOL) :: uuid_format__tmp
       LOGICAL, OPTIONAL, INTENT(OUT) :: uuid_name_
       LOGICAL(KIND=C_BOOL) :: uuid_name__tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: writer_
+      LOGICAL(KIND=C_BOOL) :: writer__tmp
 
       IF (PRESENT(append_)) THEN
@@ -1027,4 +1204,10 @@
       ENDIF
 
+      IF (PRESENT(gatherer_)) THEN
+        gatherer__tmp = cxios_is_defined_filegroup_gatherer &
+      (filegroup_hdl%daddr)
+        gatherer_ = gatherer__tmp
+      ENDIF
+
       IF (PRESENT(group_ref_)) THEN
         group_ref__tmp = cxios_is_defined_filegroup_group_ref &
@@ -1075,4 +1258,22 @@
       ENDIF
 
+      IF (PRESENT(pool_gatherer_)) THEN
+        pool_gatherer__tmp = cxios_is_defined_filegroup_pool_gatherer &
+      (filegroup_hdl%daddr)
+        pool_gatherer_ = pool_gatherer__tmp
+      ENDIF
+
+      IF (PRESENT(pool_reader_)) THEN
+        pool_reader__tmp = cxios_is_defined_filegroup_pool_reader &
+      (filegroup_hdl%daddr)
+        pool_reader_ = pool_reader__tmp
+      ENDIF
+
+      IF (PRESENT(pool_writer_)) THEN
+        pool_writer__tmp = cxios_is_defined_filegroup_pool_writer &
+      (filegroup_hdl%daddr)
+        pool_writer_ = pool_writer__tmp
+      ENDIF
+
       IF (PRESENT(read_metadata_par_)) THEN
         read_metadata_par__tmp = cxios_is_defined_filegroup_read_metadata_par &
@@ -1081,4 +1282,10 @@
       ENDIF
 
+      IF (PRESENT(reader_)) THEN
+        reader__tmp = cxios_is_defined_filegroup_reader &
+      (filegroup_hdl%daddr)
+        reader_ = reader__tmp
+      ENDIF
+
       IF (PRESENT(record_offset_)) THEN
         record_offset__tmp = cxios_is_defined_filegroup_record_offset &
@@ -1171,4 +1378,10 @@
       ENDIF
 
+      IF (PRESENT(using_server2_)) THEN
+        using_server2__tmp = cxios_is_defined_filegroup_using_server2 &
+      (filegroup_hdl%daddr)
+        using_server2_ = using_server2__tmp
+      ENDIF
+
       IF (PRESENT(uuid_format_)) THEN
         uuid_format__tmp = cxios_is_defined_filegroup_uuid_format &
@@ -1183,4 +1396,10 @@
       ENDIF
 
+      IF (PRESENT(writer_)) THEN
+        writer__tmp = cxios_is_defined_filegroup_writer &
+      (filegroup_hdl%daddr)
+        writer_ = writer__tmp
+      ENDIF
+
   END SUBROUTINE xios(is_defined_filegroup_attr_hdl_)
 
Index: XIOS3/trunk/src/interface/fortran_attr/iredistribute_axis_attr.F90
===================================================================
--- XIOS3/trunk/src/interface/fortran_attr/iredistribute_axis_attr.F90	(revision 2616)
+++ XIOS3/trunk/src/interface/fortran_attr/iredistribute_axis_attr.F90	(revision 2616)
@@ -0,0 +1,206 @@
+! * ************************************************************************** *
+! *               Interface auto generated - do not modify                     *
+! * ************************************************************************** *
+#include "xios_fortran_prefix.hpp"
+
+MODULE iredistribute_axis_attr
+  USE, INTRINSIC :: ISO_C_BINDING
+  USE iredistribute_axis
+  USE redistribute_axis_interface_attr
+
+CONTAINS
+
+  SUBROUTINE xios(set_redistribute_axis_attr)  &
+    ( redistribute_axis_id, index, mask, type )
+
+    IMPLICIT NONE
+      TYPE(txios(redistribute_axis))  :: redistribute_axis_hdl
+      CHARACTER(LEN=*), INTENT(IN) ::redistribute_axis_id
+      INTEGER  , OPTIONAL, INTENT(IN) :: index(:)
+      LOGICAL  , OPTIONAL, INTENT(IN) :: mask(:)
+      LOGICAL (KIND=C_BOOL) , ALLOCATABLE :: mask_tmp(:)
+      CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: type
+
+      CALL xios(get_redistribute_axis_handle) &
+      (redistribute_axis_id,redistribute_axis_hdl)
+      CALL xios(set_redistribute_axis_attr_hdl_)   &
+      ( redistribute_axis_hdl, index, mask, type )
+
+  END SUBROUTINE xios(set_redistribute_axis_attr)
+
+  SUBROUTINE xios(set_redistribute_axis_attr_hdl)  &
+    ( redistribute_axis_hdl, index, mask, type )
+
+    IMPLICIT NONE
+      TYPE(txios(redistribute_axis)) , INTENT(IN) :: redistribute_axis_hdl
+      INTEGER  , OPTIONAL, INTENT(IN) :: index(:)
+      LOGICAL  , OPTIONAL, INTENT(IN) :: mask(:)
+      LOGICAL (KIND=C_BOOL) , ALLOCATABLE :: mask_tmp(:)
+      CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: type
+
+      CALL xios(set_redistribute_axis_attr_hdl_)  &
+      ( redistribute_axis_hdl, index, mask, type )
+
+  END SUBROUTINE xios(set_redistribute_axis_attr_hdl)
+
+  SUBROUTINE xios(set_redistribute_axis_attr_hdl_)   &
+    ( redistribute_axis_hdl, index_, mask_, type_ )
+
+    IMPLICIT NONE
+      TYPE(txios(redistribute_axis)) , INTENT(IN) :: redistribute_axis_hdl
+      INTEGER  , OPTIONAL, INTENT(IN) :: index_(:)
+      LOGICAL  , OPTIONAL, INTENT(IN) :: mask_(:)
+      LOGICAL (KIND=C_BOOL) , ALLOCATABLE :: mask__tmp(:)
+      CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: type_
+
+      IF (PRESENT(index_)) THEN
+        CALL cxios_set_redistribute_axis_index &
+      (redistribute_axis_hdl%daddr, index_, SHAPE(index_))
+      ENDIF
+
+      IF (PRESENT(mask_)) THEN
+        ALLOCATE(mask__tmp(SIZE(mask_,1)))
+        mask__tmp = mask_
+        CALL cxios_set_redistribute_axis_mask &
+      (redistribute_axis_hdl%daddr, mask__tmp, SHAPE(mask_))
+      ENDIF
+
+      IF (PRESENT(type_)) THEN
+        CALL cxios_set_redistribute_axis_type &
+      (redistribute_axis_hdl%daddr, type_, len(type_))
+      ENDIF
+
+  END SUBROUTINE xios(set_redistribute_axis_attr_hdl_)
+
+  SUBROUTINE xios(get_redistribute_axis_attr)  &
+    ( redistribute_axis_id, index, mask, type )
+
+    IMPLICIT NONE
+      TYPE(txios(redistribute_axis))  :: redistribute_axis_hdl
+      CHARACTER(LEN=*), INTENT(IN) ::redistribute_axis_id
+      INTEGER  , OPTIONAL, INTENT(OUT) :: index(:)
+      LOGICAL  , OPTIONAL, INTENT(OUT) :: mask(:)
+      LOGICAL (KIND=C_BOOL) , ALLOCATABLE :: mask_tmp(:)
+      CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: type
+
+      CALL xios(get_redistribute_axis_handle) &
+      (redistribute_axis_id,redistribute_axis_hdl)
+      CALL xios(get_redistribute_axis_attr_hdl_)   &
+      ( redistribute_axis_hdl, index, mask, type )
+
+  END SUBROUTINE xios(get_redistribute_axis_attr)
+
+  SUBROUTINE xios(get_redistribute_axis_attr_hdl)  &
+    ( redistribute_axis_hdl, index, mask, type )
+
+    IMPLICIT NONE
+      TYPE(txios(redistribute_axis)) , INTENT(IN) :: redistribute_axis_hdl
+      INTEGER  , OPTIONAL, INTENT(OUT) :: index(:)
+      LOGICAL  , OPTIONAL, INTENT(OUT) :: mask(:)
+      LOGICAL (KIND=C_BOOL) , ALLOCATABLE :: mask_tmp(:)
+      CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: type
+
+      CALL xios(get_redistribute_axis_attr_hdl_)  &
+      ( redistribute_axis_hdl, index, mask, type )
+
+  END SUBROUTINE xios(get_redistribute_axis_attr_hdl)
+
+  SUBROUTINE xios(get_redistribute_axis_attr_hdl_)   &
+    ( redistribute_axis_hdl, index_, mask_, type_ )
+
+    IMPLICIT NONE
+      TYPE(txios(redistribute_axis)) , INTENT(IN) :: redistribute_axis_hdl
+      INTEGER  , OPTIONAL, INTENT(OUT) :: index_(:)
+      LOGICAL  , OPTIONAL, INTENT(OUT) :: mask_(:)
+      LOGICAL (KIND=C_BOOL) , ALLOCATABLE :: mask__tmp(:)
+      CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: type_
+
+      IF (PRESENT(index_)) THEN
+        CALL cxios_get_redistribute_axis_index &
+      (redistribute_axis_hdl%daddr, index_, SHAPE(index_))
+      ENDIF
+
+      IF (PRESENT(mask_)) THEN
+        ALLOCATE(mask__tmp(SIZE(mask_,1)))
+        CALL cxios_get_redistribute_axis_mask &
+      (redistribute_axis_hdl%daddr, mask__tmp, SHAPE(mask_))
+        mask_ = mask__tmp
+      ENDIF
+
+      IF (PRESENT(type_)) THEN
+        CALL cxios_get_redistribute_axis_type &
+      (redistribute_axis_hdl%daddr, type_, len(type_))
+      ENDIF
+
+  END SUBROUTINE xios(get_redistribute_axis_attr_hdl_)
+
+  SUBROUTINE xios(is_defined_redistribute_axis_attr)  &
+    ( redistribute_axis_id, index, mask, type )
+
+    IMPLICIT NONE
+      TYPE(txios(redistribute_axis))  :: redistribute_axis_hdl
+      CHARACTER(LEN=*), INTENT(IN) ::redistribute_axis_id
+      LOGICAL, OPTIONAL, INTENT(OUT) :: index
+      LOGICAL(KIND=C_BOOL) :: index_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: mask
+      LOGICAL(KIND=C_BOOL) :: mask_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: type
+      LOGICAL(KIND=C_BOOL) :: type_tmp
+
+      CALL xios(get_redistribute_axis_handle) &
+      (redistribute_axis_id,redistribute_axis_hdl)
+      CALL xios(is_defined_redistribute_axis_attr_hdl_)   &
+      ( redistribute_axis_hdl, index, mask, type )
+
+  END SUBROUTINE xios(is_defined_redistribute_axis_attr)
+
+  SUBROUTINE xios(is_defined_redistribute_axis_attr_hdl)  &
+    ( redistribute_axis_hdl, index, mask, type )
+
+    IMPLICIT NONE
+      TYPE(txios(redistribute_axis)) , INTENT(IN) :: redistribute_axis_hdl
+      LOGICAL, OPTIONAL, INTENT(OUT) :: index
+      LOGICAL(KIND=C_BOOL) :: index_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: mask
+      LOGICAL(KIND=C_BOOL) :: mask_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: type
+      LOGICAL(KIND=C_BOOL) :: type_tmp
+
+      CALL xios(is_defined_redistribute_axis_attr_hdl_)  &
+      ( redistribute_axis_hdl, index, mask, type )
+
+  END SUBROUTINE xios(is_defined_redistribute_axis_attr_hdl)
+
+  SUBROUTINE xios(is_defined_redistribute_axis_attr_hdl_)   &
+    ( redistribute_axis_hdl, index_, mask_, type_ )
+
+    IMPLICIT NONE
+      TYPE(txios(redistribute_axis)) , INTENT(IN) :: redistribute_axis_hdl
+      LOGICAL, OPTIONAL, INTENT(OUT) :: index_
+      LOGICAL(KIND=C_BOOL) :: index__tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: mask_
+      LOGICAL(KIND=C_BOOL) :: mask__tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: type_
+      LOGICAL(KIND=C_BOOL) :: type__tmp
+
+      IF (PRESENT(index_)) THEN
+        index__tmp = cxios_is_defined_redistribute_axis_index &
+      (redistribute_axis_hdl%daddr)
+        index_ = index__tmp
+      ENDIF
+
+      IF (PRESENT(mask_)) THEN
+        mask__tmp = cxios_is_defined_redistribute_axis_mask &
+      (redistribute_axis_hdl%daddr)
+        mask_ = mask__tmp
+      ENDIF
+
+      IF (PRESENT(type_)) THEN
+        type__tmp = cxios_is_defined_redistribute_axis_type &
+      (redistribute_axis_hdl%daddr)
+        type_ = type__tmp
+      ENDIF
+
+  END SUBROUTINE xios(is_defined_redistribute_axis_attr_hdl_)
+
+END MODULE iredistribute_axis_attr
Index: XIOS3/trunk/src/interface/fortran_attr/iredistribute_domain_attr.F90
===================================================================
--- XIOS3/trunk/src/interface/fortran_attr/iredistribute_domain_attr.F90	(revision 2616)
+++ XIOS3/trunk/src/interface/fortran_attr/iredistribute_domain_attr.F90	(revision 2616)
@@ -0,0 +1,206 @@
+! * ************************************************************************** *
+! *               Interface auto generated - do not modify                     *
+! * ************************************************************************** *
+#include "xios_fortran_prefix.hpp"
+
+MODULE iredistribute_domain_attr
+  USE, INTRINSIC :: ISO_C_BINDING
+  USE iredistribute_domain
+  USE redistribute_domain_interface_attr
+
+CONTAINS
+
+  SUBROUTINE xios(set_redistribute_domain_attr)  &
+    ( redistribute_domain_id, index, mask, type )
+
+    IMPLICIT NONE
+      TYPE(txios(redistribute_domain))  :: redistribute_domain_hdl
+      CHARACTER(LEN=*), INTENT(IN) ::redistribute_domain_id
+      INTEGER  , OPTIONAL, INTENT(IN) :: index(:)
+      LOGICAL  , OPTIONAL, INTENT(IN) :: mask(:)
+      LOGICAL (KIND=C_BOOL) , ALLOCATABLE :: mask_tmp(:)
+      CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: type
+
+      CALL xios(get_redistribute_domain_handle) &
+      (redistribute_domain_id,redistribute_domain_hdl)
+      CALL xios(set_redistribute_domain_attr_hdl_)   &
+      ( redistribute_domain_hdl, index, mask, type )
+
+  END SUBROUTINE xios(set_redistribute_domain_attr)
+
+  SUBROUTINE xios(set_redistribute_domain_attr_hdl)  &
+    ( redistribute_domain_hdl, index, mask, type )
+
+    IMPLICIT NONE
+      TYPE(txios(redistribute_domain)) , INTENT(IN) :: redistribute_domain_hdl
+      INTEGER  , OPTIONAL, INTENT(IN) :: index(:)
+      LOGICAL  , OPTIONAL, INTENT(IN) :: mask(:)
+      LOGICAL (KIND=C_BOOL) , ALLOCATABLE :: mask_tmp(:)
+      CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: type
+
+      CALL xios(set_redistribute_domain_attr_hdl_)  &
+      ( redistribute_domain_hdl, index, mask, type )
+
+  END SUBROUTINE xios(set_redistribute_domain_attr_hdl)
+
+  SUBROUTINE xios(set_redistribute_domain_attr_hdl_)   &
+    ( redistribute_domain_hdl, index_, mask_, type_ )
+
+    IMPLICIT NONE
+      TYPE(txios(redistribute_domain)) , INTENT(IN) :: redistribute_domain_hdl
+      INTEGER  , OPTIONAL, INTENT(IN) :: index_(:)
+      LOGICAL  , OPTIONAL, INTENT(IN) :: mask_(:)
+      LOGICAL (KIND=C_BOOL) , ALLOCATABLE :: mask__tmp(:)
+      CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: type_
+
+      IF (PRESENT(index_)) THEN
+        CALL cxios_set_redistribute_domain_index &
+      (redistribute_domain_hdl%daddr, index_, SHAPE(index_))
+      ENDIF
+
+      IF (PRESENT(mask_)) THEN
+        ALLOCATE(mask__tmp(SIZE(mask_,1)))
+        mask__tmp = mask_
+        CALL cxios_set_redistribute_domain_mask &
+      (redistribute_domain_hdl%daddr, mask__tmp, SHAPE(mask_))
+      ENDIF
+
+      IF (PRESENT(type_)) THEN
+        CALL cxios_set_redistribute_domain_type &
+      (redistribute_domain_hdl%daddr, type_, len(type_))
+      ENDIF
+
+  END SUBROUTINE xios(set_redistribute_domain_attr_hdl_)
+
+  SUBROUTINE xios(get_redistribute_domain_attr)  &
+    ( redistribute_domain_id, index, mask, type )
+
+    IMPLICIT NONE
+      TYPE(txios(redistribute_domain))  :: redistribute_domain_hdl
+      CHARACTER(LEN=*), INTENT(IN) ::redistribute_domain_id
+      INTEGER  , OPTIONAL, INTENT(OUT) :: index(:)
+      LOGICAL  , OPTIONAL, INTENT(OUT) :: mask(:)
+      LOGICAL (KIND=C_BOOL) , ALLOCATABLE :: mask_tmp(:)
+      CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: type
+
+      CALL xios(get_redistribute_domain_handle) &
+      (redistribute_domain_id,redistribute_domain_hdl)
+      CALL xios(get_redistribute_domain_attr_hdl_)   &
+      ( redistribute_domain_hdl, index, mask, type )
+
+  END SUBROUTINE xios(get_redistribute_domain_attr)
+
+  SUBROUTINE xios(get_redistribute_domain_attr_hdl)  &
+    ( redistribute_domain_hdl, index, mask, type )
+
+    IMPLICIT NONE
+      TYPE(txios(redistribute_domain)) , INTENT(IN) :: redistribute_domain_hdl
+      INTEGER  , OPTIONAL, INTENT(OUT) :: index(:)
+      LOGICAL  , OPTIONAL, INTENT(OUT) :: mask(:)
+      LOGICAL (KIND=C_BOOL) , ALLOCATABLE :: mask_tmp(:)
+      CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: type
+
+      CALL xios(get_redistribute_domain_attr_hdl_)  &
+      ( redistribute_domain_hdl, index, mask, type )
+
+  END SUBROUTINE xios(get_redistribute_domain_attr_hdl)
+
+  SUBROUTINE xios(get_redistribute_domain_attr_hdl_)   &
+    ( redistribute_domain_hdl, index_, mask_, type_ )
+
+    IMPLICIT NONE
+      TYPE(txios(redistribute_domain)) , INTENT(IN) :: redistribute_domain_hdl
+      INTEGER  , OPTIONAL, INTENT(OUT) :: index_(:)
+      LOGICAL  , OPTIONAL, INTENT(OUT) :: mask_(:)
+      LOGICAL (KIND=C_BOOL) , ALLOCATABLE :: mask__tmp(:)
+      CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: type_
+
+      IF (PRESENT(index_)) THEN
+        CALL cxios_get_redistribute_domain_index &
+      (redistribute_domain_hdl%daddr, index_, SHAPE(index_))
+      ENDIF
+
+      IF (PRESENT(mask_)) THEN
+        ALLOCATE(mask__tmp(SIZE(mask_,1)))
+        CALL cxios_get_redistribute_domain_mask &
+      (redistribute_domain_hdl%daddr, mask__tmp, SHAPE(mask_))
+        mask_ = mask__tmp
+      ENDIF
+
+      IF (PRESENT(type_)) THEN
+        CALL cxios_get_redistribute_domain_type &
+      (redistribute_domain_hdl%daddr, type_, len(type_))
+      ENDIF
+
+  END SUBROUTINE xios(get_redistribute_domain_attr_hdl_)
+
+  SUBROUTINE xios(is_defined_redistribute_domain_attr)  &
+    ( redistribute_domain_id, index, mask, type )
+
+    IMPLICIT NONE
+      TYPE(txios(redistribute_domain))  :: redistribute_domain_hdl
+      CHARACTER(LEN=*), INTENT(IN) ::redistribute_domain_id
+      LOGICAL, OPTIONAL, INTENT(OUT) :: index
+      LOGICAL(KIND=C_BOOL) :: index_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: mask
+      LOGICAL(KIND=C_BOOL) :: mask_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: type
+      LOGICAL(KIND=C_BOOL) :: type_tmp
+
+      CALL xios(get_redistribute_domain_handle) &
+      (redistribute_domain_id,redistribute_domain_hdl)
+      CALL xios(is_defined_redistribute_domain_attr_hdl_)   &
+      ( redistribute_domain_hdl, index, mask, type )
+
+  END SUBROUTINE xios(is_defined_redistribute_domain_attr)
+
+  SUBROUTINE xios(is_defined_redistribute_domain_attr_hdl)  &
+    ( redistribute_domain_hdl, index, mask, type )
+
+    IMPLICIT NONE
+      TYPE(txios(redistribute_domain)) , INTENT(IN) :: redistribute_domain_hdl
+      LOGICAL, OPTIONAL, INTENT(OUT) :: index
+      LOGICAL(KIND=C_BOOL) :: index_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: mask
+      LOGICAL(KIND=C_BOOL) :: mask_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: type
+      LOGICAL(KIND=C_BOOL) :: type_tmp
+
+      CALL xios(is_defined_redistribute_domain_attr_hdl_)  &
+      ( redistribute_domain_hdl, index, mask, type )
+
+  END SUBROUTINE xios(is_defined_redistribute_domain_attr_hdl)
+
+  SUBROUTINE xios(is_defined_redistribute_domain_attr_hdl_)   &
+    ( redistribute_domain_hdl, index_, mask_, type_ )
+
+    IMPLICIT NONE
+      TYPE(txios(redistribute_domain)) , INTENT(IN) :: redistribute_domain_hdl
+      LOGICAL, OPTIONAL, INTENT(OUT) :: index_
+      LOGICAL(KIND=C_BOOL) :: index__tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: mask_
+      LOGICAL(KIND=C_BOOL) :: mask__tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: type_
+      LOGICAL(KIND=C_BOOL) :: type__tmp
+
+      IF (PRESENT(index_)) THEN
+        index__tmp = cxios_is_defined_redistribute_domain_index &
+      (redistribute_domain_hdl%daddr)
+        index_ = index__tmp
+      ENDIF
+
+      IF (PRESENT(mask_)) THEN
+        mask__tmp = cxios_is_defined_redistribute_domain_mask &
+      (redistribute_domain_hdl%daddr)
+        mask_ = mask__tmp
+      ENDIF
+
+      IF (PRESENT(type_)) THEN
+        type__tmp = cxios_is_defined_redistribute_domain_type &
+      (redistribute_domain_hdl%daddr)
+        type_ = type__tmp
+      ENDIF
+
+  END SUBROUTINE xios(is_defined_redistribute_domain_attr_hdl_)
+
+END MODULE iredistribute_domain_attr
Index: XIOS3/trunk/src/interface/fortran_attr/iredistribute_scalar_attr.F90
===================================================================
--- XIOS3/trunk/src/interface/fortran_attr/iredistribute_scalar_attr.F90	(revision 2616)
+++ XIOS3/trunk/src/interface/fortran_attr/iredistribute_scalar_attr.F90	(revision 2616)
@@ -0,0 +1,206 @@
+! * ************************************************************************** *
+! *               Interface auto generated - do not modify                     *
+! * ************************************************************************** *
+#include "xios_fortran_prefix.hpp"
+
+MODULE iredistribute_scalar_attr
+  USE, INTRINSIC :: ISO_C_BINDING
+  USE iredistribute_scalar
+  USE redistribute_scalar_interface_attr
+
+CONTAINS
+
+  SUBROUTINE xios(set_redistribute_scalar_attr)  &
+    ( redistribute_scalar_id, index, mask, type )
+
+    IMPLICIT NONE
+      TYPE(txios(redistribute_scalar))  :: redistribute_scalar_hdl
+      CHARACTER(LEN=*), INTENT(IN) ::redistribute_scalar_id
+      INTEGER  , OPTIONAL, INTENT(IN) :: index(:)
+      LOGICAL  , OPTIONAL, INTENT(IN) :: mask(:)
+      LOGICAL (KIND=C_BOOL) , ALLOCATABLE :: mask_tmp(:)
+      CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: type
+
+      CALL xios(get_redistribute_scalar_handle) &
+      (redistribute_scalar_id,redistribute_scalar_hdl)
+      CALL xios(set_redistribute_scalar_attr_hdl_)   &
+      ( redistribute_scalar_hdl, index, mask, type )
+
+  END SUBROUTINE xios(set_redistribute_scalar_attr)
+
+  SUBROUTINE xios(set_redistribute_scalar_attr_hdl)  &
+    ( redistribute_scalar_hdl, index, mask, type )
+
+    IMPLICIT NONE
+      TYPE(txios(redistribute_scalar)) , INTENT(IN) :: redistribute_scalar_hdl
+      INTEGER  , OPTIONAL, INTENT(IN) :: index(:)
+      LOGICAL  , OPTIONAL, INTENT(IN) :: mask(:)
+      LOGICAL (KIND=C_BOOL) , ALLOCATABLE :: mask_tmp(:)
+      CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: type
+
+      CALL xios(set_redistribute_scalar_attr_hdl_)  &
+      ( redistribute_scalar_hdl, index, mask, type )
+
+  END SUBROUTINE xios(set_redistribute_scalar_attr_hdl)
+
+  SUBROUTINE xios(set_redistribute_scalar_attr_hdl_)   &
+    ( redistribute_scalar_hdl, index_, mask_, type_ )
+
+    IMPLICIT NONE
+      TYPE(txios(redistribute_scalar)) , INTENT(IN) :: redistribute_scalar_hdl
+      INTEGER  , OPTIONAL, INTENT(IN) :: index_(:)
+      LOGICAL  , OPTIONAL, INTENT(IN) :: mask_(:)
+      LOGICAL (KIND=C_BOOL) , ALLOCATABLE :: mask__tmp(:)
+      CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: type_
+
+      IF (PRESENT(index_)) THEN
+        CALL cxios_set_redistribute_scalar_index &
+      (redistribute_scalar_hdl%daddr, index_, SHAPE(index_))
+      ENDIF
+
+      IF (PRESENT(mask_)) THEN
+        ALLOCATE(mask__tmp(SIZE(mask_,1)))
+        mask__tmp = mask_
+        CALL cxios_set_redistribute_scalar_mask &
+      (redistribute_scalar_hdl%daddr, mask__tmp, SHAPE(mask_))
+      ENDIF
+
+      IF (PRESENT(type_)) THEN
+        CALL cxios_set_redistribute_scalar_type &
+      (redistribute_scalar_hdl%daddr, type_, len(type_))
+      ENDIF
+
+  END SUBROUTINE xios(set_redistribute_scalar_attr_hdl_)
+
+  SUBROUTINE xios(get_redistribute_scalar_attr)  &
+    ( redistribute_scalar_id, index, mask, type )
+
+    IMPLICIT NONE
+      TYPE(txios(redistribute_scalar))  :: redistribute_scalar_hdl
+      CHARACTER(LEN=*), INTENT(IN) ::redistribute_scalar_id
+      INTEGER  , OPTIONAL, INTENT(OUT) :: index(:)
+      LOGICAL  , OPTIONAL, INTENT(OUT) :: mask(:)
+      LOGICAL (KIND=C_BOOL) , ALLOCATABLE :: mask_tmp(:)
+      CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: type
+
+      CALL xios(get_redistribute_scalar_handle) &
+      (redistribute_scalar_id,redistribute_scalar_hdl)
+      CALL xios(get_redistribute_scalar_attr_hdl_)   &
+      ( redistribute_scalar_hdl, index, mask, type )
+
+  END SUBROUTINE xios(get_redistribute_scalar_attr)
+
+  SUBROUTINE xios(get_redistribute_scalar_attr_hdl)  &
+    ( redistribute_scalar_hdl, index, mask, type )
+
+    IMPLICIT NONE
+      TYPE(txios(redistribute_scalar)) , INTENT(IN) :: redistribute_scalar_hdl
+      INTEGER  , OPTIONAL, INTENT(OUT) :: index(:)
+      LOGICAL  , OPTIONAL, INTENT(OUT) :: mask(:)
+      LOGICAL (KIND=C_BOOL) , ALLOCATABLE :: mask_tmp(:)
+      CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: type
+
+      CALL xios(get_redistribute_scalar_attr_hdl_)  &
+      ( redistribute_scalar_hdl, index, mask, type )
+
+  END SUBROUTINE xios(get_redistribute_scalar_attr_hdl)
+
+  SUBROUTINE xios(get_redistribute_scalar_attr_hdl_)   &
+    ( redistribute_scalar_hdl, index_, mask_, type_ )
+
+    IMPLICIT NONE
+      TYPE(txios(redistribute_scalar)) , INTENT(IN) :: redistribute_scalar_hdl
+      INTEGER  , OPTIONAL, INTENT(OUT) :: index_(:)
+      LOGICAL  , OPTIONAL, INTENT(OUT) :: mask_(:)
+      LOGICAL (KIND=C_BOOL) , ALLOCATABLE :: mask__tmp(:)
+      CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: type_
+
+      IF (PRESENT(index_)) THEN
+        CALL cxios_get_redistribute_scalar_index &
+      (redistribute_scalar_hdl%daddr, index_, SHAPE(index_))
+      ENDIF
+
+      IF (PRESENT(mask_)) THEN
+        ALLOCATE(mask__tmp(SIZE(mask_,1)))
+        CALL cxios_get_redistribute_scalar_mask &
+      (redistribute_scalar_hdl%daddr, mask__tmp, SHAPE(mask_))
+        mask_ = mask__tmp
+      ENDIF
+
+      IF (PRESENT(type_)) THEN
+        CALL cxios_get_redistribute_scalar_type &
+      (redistribute_scalar_hdl%daddr, type_, len(type_))
+      ENDIF
+
+  END SUBROUTINE xios(get_redistribute_scalar_attr_hdl_)
+
+  SUBROUTINE xios(is_defined_redistribute_scalar_attr)  &
+    ( redistribute_scalar_id, index, mask, type )
+
+    IMPLICIT NONE
+      TYPE(txios(redistribute_scalar))  :: redistribute_scalar_hdl
+      CHARACTER(LEN=*), INTENT(IN) ::redistribute_scalar_id
+      LOGICAL, OPTIONAL, INTENT(OUT) :: index
+      LOGICAL(KIND=C_BOOL) :: index_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: mask
+      LOGICAL(KIND=C_BOOL) :: mask_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: type
+      LOGICAL(KIND=C_BOOL) :: type_tmp
+
+      CALL xios(get_redistribute_scalar_handle) &
+      (redistribute_scalar_id,redistribute_scalar_hdl)
+      CALL xios(is_defined_redistribute_scalar_attr_hdl_)   &
+      ( redistribute_scalar_hdl, index, mask, type )
+
+  END SUBROUTINE xios(is_defined_redistribute_scalar_attr)
+
+  SUBROUTINE xios(is_defined_redistribute_scalar_attr_hdl)  &
+    ( redistribute_scalar_hdl, index, mask, type )
+
+    IMPLICIT NONE
+      TYPE(txios(redistribute_scalar)) , INTENT(IN) :: redistribute_scalar_hdl
+      LOGICAL, OPTIONAL, INTENT(OUT) :: index
+      LOGICAL(KIND=C_BOOL) :: index_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: mask
+      LOGICAL(KIND=C_BOOL) :: mask_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: type
+      LOGICAL(KIND=C_BOOL) :: type_tmp
+
+      CALL xios(is_defined_redistribute_scalar_attr_hdl_)  &
+      ( redistribute_scalar_hdl, index, mask, type )
+
+  END SUBROUTINE xios(is_defined_redistribute_scalar_attr_hdl)
+
+  SUBROUTINE xios(is_defined_redistribute_scalar_attr_hdl_)   &
+    ( redistribute_scalar_hdl, index_, mask_, type_ )
+
+    IMPLICIT NONE
+      TYPE(txios(redistribute_scalar)) , INTENT(IN) :: redistribute_scalar_hdl
+      LOGICAL, OPTIONAL, INTENT(OUT) :: index_
+      LOGICAL(KIND=C_BOOL) :: index__tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: mask_
+      LOGICAL(KIND=C_BOOL) :: mask__tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: type_
+      LOGICAL(KIND=C_BOOL) :: type__tmp
+
+      IF (PRESENT(index_)) THEN
+        index__tmp = cxios_is_defined_redistribute_scalar_index &
+      (redistribute_scalar_hdl%daddr)
+        index_ = index__tmp
+      ENDIF
+
+      IF (PRESENT(mask_)) THEN
+        mask__tmp = cxios_is_defined_redistribute_scalar_mask &
+      (redistribute_scalar_hdl%daddr)
+        mask_ = mask__tmp
+      ENDIF
+
+      IF (PRESENT(type_)) THEN
+        type__tmp = cxios_is_defined_redistribute_scalar_type &
+      (redistribute_scalar_hdl%daddr)
+        type_ = type__tmp
+      ENDIF
+
+  END SUBROUTINE xios(is_defined_redistribute_scalar_attr_hdl_)
+
+END MODULE iredistribute_scalar_attr
